/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* SPDX-License-Identifier: Apache-2.0                                                                     */
/* Copyright(c) 2020 Nuvoton Technology Corp. All rights reserved.                                         */
/*                                                                                                         */
/*---------------------------------------------------------------------------------------------------------*/
#include "ml51.h"

/************************************************************************************************************/
/* FUNCTION_PURPOSE: Timer3 interrupt Service Routine                                                          */
/************************************************************************************************************/
void Timer3_ISR (void) interrupt 16
{
    PUSH_SFRS;

    clr_T3CON_TF3;
    GPIO_LED ^= 1;

    POP_SFRS;
}

/************************************************************************************************************/
/* FUNCTION_PURPOSE: Main Loop                                                                              */
/************************************************************************************************************/
void main (void)
{

    GPIO_LED_QUASI_MODE;

    Timer3_AutoReload_Interrupt_Initial(24,6400);
    ENABLE_GLOBAL_INTERRUPT;

    while(1);
}

